﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace _92990
{
    public partial class Form1 : Form
    {
        public enum Names{Ivan, Jhon, Scott, Paul, Marco};
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dropDownTable = new DataTable();
            dropDownTable.Columns.Add("ID", typeof(int)).AutoIncrement = true;
            dropDownTable.PrimaryKey = new DataColumn[] { dropDownTable.Columns["ID"] };
            dropDownTable.Columns.Add("Order #", typeof(string));
            dropDownTable.Columns.Add("Customer", typeof(string));
            for (int i = 0; i < 25; i++)
			{
                dropDownTable.Rows.Add(null, string.Format("Order {0,2}", i),
                    ((Names)(i % 5)).ToString());
			}

            ultraCombo1.DataSource = dropDownTable;
            ultraCombo1.ValueMember = "ID";
            ultraCombo1.DisplayMember = "Order #";

            DataTable gridTable = new DataTable();
            gridTable.Columns.Add("Order", typeof(int));

            
            ultraGrid1.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(ultraGrid1_InitializeLayout);
            ultraGrid1.AfterCellUpdate += new Infragistics.Win.UltraWinGrid.CellEventHandler(ultraGrid1_AfterCellUpdate);
           
            
            Random rnd = new Random();
            for (int i = 0; i < 10; i++)
            {
                gridTable.Rows.Add(rnd.Next(0, 24));
                Thread.Sleep(3);
            }

            ultraGrid1.DataSource = gridTable;

            foreach (UltraGridRow row in ultraGrid1.Rows)
            {
                int key = (int)row.Cells["Order"].Value ;
                DataRow val = dropDownTable.Rows.Find(key);
                row.Cells["Name"].Value = val["Customer"];
            }
        }

        void ultraGrid1_AfterCellUpdate(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
           if (e.Cell.Column.Key == "Order")
            {
               UltraCombo c = e.Cell.ValueListResolved  as UltraCombo;
               DataRowView val = (DataRowView)c.SelectedRow.ListObject;
               e.Cell.Row.Cells["Name"].Value = val["Customer"];
            } 
        }

        void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns.Add("Name").CellActivation = Activation.NoEdit;
            e.Layout.Bands[0].Columns["Order"].ValueList = ultraCombo1;
        }
    }
}
